package extensions;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.charset.Charset;
import java.net.URLDecoder;
import java.net.Socket;
import java.net.URLEncoder;
import java.net.URLDecoder;
import java.text.DateFormat;
import java.util.Calendar;
import java.util.Collections;
import java.util.Map;
import java.util.HashMap;
import java.util.Random;
import java.util.Set;
import java.util.concurrent.Executors;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.Semaphore;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import dareka.Main;
import dareka.common.CloseUtil;
import dareka.common.DiskFreeSpace;
import dareka.common.Logger;
import dareka.common.Pair;
import dareka.extensions.Extension2;
import dareka.extensions.ExtensionManager;
import dareka.extensions.RequestFilter;
import dareka.extensions.Rewriter;
import dareka.processor.HttpRequestHeader;
import dareka.processor.HttpResponseHeader;
import dareka.processor.Resource;
import dareka.processor.URLResource;
import dareka.processor.StringResource;
import dareka.processor.TransferListener;
import dareka.processor.Processor;
import dareka.processor.impl.Cache;
import dareka.processor.impl.NicoCachingTitleRetriever;
import dareka.processor.util.GetThumbInfoUtil;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.PreparedStatement;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;

public class UnlimitedMyList implements Extension2, Processor {
	public static final String LOG_PREFIX = "ml";
	public static final String PROP_DEBUG = "myListDebug";
	private static final String[] PROCESSOR_SUPPORTED_METHODS = new String[] { "GET" };
	private static final Pattern PROCESSOR_SUPPORTED_PATTERN = Pattern.compile(
			"^(http://[^/]+\\.(?:nico|smile)video\\.jp)/umylist(/.*)$");
	private static final Pattern PATH_SMILE_PATTERN = Pattern.compile(
			"^/smile\\?s=(\\d+)\\.\\d+$");
	private static final Pattern PATH_SWFHEADER_PATTERN = Pattern.compile(
			"^/(?:madd:add)\\?(?:nm)?(\\d+)$");
	private static ExtUtil util;
	private static Connection con;
	private Statement stmt;
	
	private void updateTable(String tableName,String colName,String type) {
		boolean e = false;
		try {
			ResultSet rs = stmt.executeQuery("PRAGMA table_info('"+tableName+"')");
			while( rs.next() ) {
				if( rs.getString("name") == colName ) {
					e = true;
					break;
				}
			}
			rs.close();
			if( !e ) {
				util.info("ALTER TABLE "+tableName+" ADD COLUMN "+colName+" "+type);
				stmt.execute("ALTER TABLE "+tableName+" ADD COLUMN "+colName+" "+type);
			}
		} catch( Exception exc ) {
		}
		util.info(colName+" "+e);
	}
	
	private void updateTable(String tableName,String colName,String type,String def) {
		boolean e = false;
		final String pre = "updateTable()";
		try {
			info(pre,"PRAGMA table_info('"+tableName+"')");
			ResultSet rs = stmt.executeQuery("PRAGMA table_info('"+tableName+"')");
			while( rs.next() ) {
				info(pre,rs.getString("name"));
				if( rs.getString("name").equals(colName) ) {
					e = true;
//					break;
				}
			}
			rs.close();
			if( !e ) {
				info(pre,"ALTER TABLE "+tableName+" ADD COLUMN "+colName+" "+type);
				stmt.execute("ALTER TABLE "+tableName+" ADD COLUMN "+colName+" "+type+" default '"+def+"'");
			}
		} catch( Exception exc ) {
			info(pre,"err:"+exc);
		}
		info(pre,colName+" "+e);
	}

	public void registerExtensions(ExtensionManager mgr) {
		final String pre = "registerExtensions()";
		if( util == null ) {
			util = new ExtUtil(this, LOG_PREFIX, PROP_DEBUG);
		}
		/* クラスの読み込みよくわからないので誤魔化した */
		try {
			URL[] urls = new URL[1];
			
			urls[0] = new URL("jar:file:/sqlite-jdbc.jar!/");
			
			ClassLoader url = new URLClassLoader(urls);
			Class.forName("org.sqlite.JDBC");
		} catch(Exception e) {
		}
		if( con == null ) {
			try {
				con = DriverManager.getConnection("jdbc:sqlite:umylist.db");	
				stmt = con.createStatement();
				// if not existsがあったのでこっち使う
				stmt.execute("create table if not exists umylist(id INTEGER PRIMARY KEY AUTOINCREMENT,name text)");
				stmt.execute("create table if not exists umovie(id INTEGER PRIMARY KEY AUTOINCREMENT,mylistid integer,movieid text)");
				stmt.execute("create table if not exists mylist(id INTEGER PRIMARY KEY AUTOINCREMENT,mylistid integer)");
				updateTable("umovie","threadid","text","-1");
				/*
				ResultSet rs;
				rs = stmt.executeQuery("SELECT count(*) FROM sqlite_master WHERE type='table' AND name='umylist';");
				rs.next();
				// テーブルなかったら作る
				if( rs.getInt(1) == 0 ) {
					stmt.execute("create table umylist(id INTEGER PRIMARY KEY AUTOINCREMENT,name text)");
				}
				rs = stmt.executeQuery("SELECT count(*) FROM sqlite_master WHERE type='table' AND name='umovie';");
				rs.next();
				if( rs.getInt(1) == 0 ) {
					stmt.execute("create table umovie(id INTEGER PRIMARY KEY AUTOINCREMENT,mylistid integer,movieid text)");
				}
				*/
			} catch(Exception e) {
				info(pre,e+"");
			}
		}
		mgr.registerProcessor(this);      // Processorとして登録
	}
	
	/**
	 * @return バージョン文字列。長いのは自重するべき。
	 */
	public String getVersionString() {
		return "Unlimited MyList 1.0";
	}

	public String[] getSupportedMethods() {
		return PROCESSOR_SUPPORTED_METHODS;
	}

	public Pattern getSupportedURLAsPattern() {
		return PROCESSOR_SUPPORTED_PATTERN;
	}
	
	public String getSupportedURLAsString() {
		return null;
	}
	
	private HashMap getQueryParameter(String s) {
		HashMap<String,String> map = new HashMap<String,String>();
		String[] v = s.split("&");
		for(int i = 0; i < v.length; i++) {
			String[] w = v[i].split("=");
			if( w.length == 2 ) {
				map.put(w[0],w[1]);
			} else {
				map.put(w[0],"");
			}
		}
		return map;
	}
	
	private String replace(String str) {
		String ret = new String(str);
		String[] escape = {"&", "<", ">", "\"", "\'"};
		String[] replace = {"&amp;", "&lt;", "&gt;", "&quot;", "&#39;"};
		for ( int i=0; i < escape.length; i++ ){
			ret = ret.replace(escape[i], replace[i]);
		}
		return ret;
	}
	
	private boolean isAcceptMID(String id) {
		Pattern pat = Pattern.compile("^[a-z]{2}\\d+$");
		Matcher mt = pat.matcher(id);
		return mt.matches();
	}
	private boolean isAcceptTID(String id) {
		Pattern pat = Pattern.compile("^\\d+$");
		Matcher mt = pat.matcher(id);
		return mt.matches();
	}
	
	private int getMovieCount(int id) {
		try {
			PreparedStatement pstmt = con.prepareStatement("SELECT COUNT(*) FROM umovie where mylistid=?");
			pstmt.setInt(1,id);
			ResultSet rs = pstmt.executeQuery();
			rs.next();
			int ret = rs.getInt(1);
			rs.close();
			return ret;
		} catch(Exception e) {
			return 0;
		}
	}

	private String getMovies(int id) {
		return getMovies(id+"");
	}
	
	private String getMovies(String id) {
		try {
			String ret = "";
			String sql = "select * from umovie where mylistid=?";
			PreparedStatement pstmt = con.prepareStatement(sql);
			pstmt.setString(1,replace(id));
			ResultSet rs = pstmt.executeQuery();
			while( rs.next() ) {
				if( !ret.equals("") ) ret += ",";
				ret += "{\"movieid\":\""+rs.getString("movieid")+"\",\"threadid\":\""+rs.getString("threadid")+"\"}";
			}
			return ret;
		} catch(Exception e) {
			return "";
		}
	}
	
	private void info(String path,String message) {
		util.info(path+" ["+message+"]");
	}
	private void debug(String path,String message) {
		if( System.getProperty("umylistDebug").equals("true") ) {
			info(path,"debug:"+message);
		}
	}
	
	public Resource onRequest(HttpRequestHeader requestHeader, Socket browser)
	throws IOException {
		try {
			Matcher m = PROCESSOR_SUPPORTED_PATTERN.matcher(requestHeader.getURI());
			if (!m.matches()) {
				throw new IOException("");
			}
			if( m.groupCount() < 2 ) {
				return util.responseText("err", "text/plain; charset=UTF-8"); 
			}
			String a = m.group(1), b = m.group(2);
			String[] tmp = b.split("\\?");
			String path = tmp[0];
			HashMap get = new HashMap();
			if( tmp.length != 1 ) {
				get = getQueryParameter(tmp[1]);
			}
			String id = "";
			if( path.equals("/list") ) {
				id += "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
				if( get.get("v") == null ) {
					id += "<mylist>\n";
					ResultSet rs = stmt.executeQuery("select * from umylist");
					while( rs.next() ) {
						id += "\t<list>\n";
						id += "\t\t<id>"+rs.getString("id")+"</id>\n";
						id += "\t\t<name>"+rs.getString("name")+"</name>\n";
						id += "\t\t<moviecount>"+getMovieCount(rs.getInt("id"))+"</moviecount>\n";
						id += "\t</list>\n";
					}
					rs.close();
					id += "</mylist>";
				} else {
					String mid = (String)get.get("v");
					debug(path,"v="+mid);
					id += "<mylist>\n";
					id += "\t<moviecount>"+getMovieCount(Integer.parseInt(mid))+"</moviecount>\n";
					String sql = "select * from umovie where mylistid=?";
					PreparedStatement pstmt = con.prepareStatement(sql);
					pstmt.setString(1,replace(mid));
					ResultSet rs = pstmt.executeQuery();
					while( rs.next() ) {
						id += "\t<list>\n";
						id += "\t\t<id>"+rs.getString("movieid")+"</id>\n";
						id += "\t\t<threadid>"+rs.getString("threadid")+"</threadid>\n";
						id += "\t</list>\n";
					}
					rs.close();
					id += "</mylist>\n";
				}
				return new StringResource(id);
			} else if( path.equals("/madd") ) {
				if( get.get("name") == null ) {
					return util.responseText("failed", "text/plain; charset=UTF-8"); 
				}
				String sql = "SELECT COUNT(*) FROM umylist where name=?";
				debug(path,"name="+(String)get.get("name"));
				String name = (String)replace(URLDecoder.decode((String)get.get("name"),"utf8"));
				debug(path,"encoded name="+name);
				ResultSet rs;
				PreparedStatement pstmt = con.prepareStatement(sql);
				pstmt.setString(1,name);
				rs = pstmt.executeQuery();
				rs.next();
				debug(path,"same name nums="+rs.getInt(1));
				// 設定されていて同じ名前のマイリストがすでに入っている
				if( !System.getProperty("umylistUniqueMyList", "false").equals("false") && rs.getInt(1) != 0 ) {
					debug(path,"overlap");
					return util.responseText("overlap", "text/plain; charset=UTF-8");
				}
				rs.close();
				sql = "INSERT INTO umylist (name) VALUES(?)";
				if( name.equals("") ) {
					return util.responseText("invalidName", "text/plain; charset=UTF-8"); 
				}
				pstmt = con.prepareStatement(sql);
				pstmt.setString(1,name);
				pstmt.execute();
				return util.responseText("succeeded", "text/plain; charset=UTF-8"); 
			} else if( path.equals("/add") ) {
				if( get.get("mid") != null && get.get("mylist") != null && get.get("tid") != null ) {
					String mylist = replace((String)get.get("mylist"));
					String mid = replace((String)get.get("mid"));
					String tid = replace((String)get.get("tid"));
					debug(path,"mylist="+mylist+" mid="+mid+" tid"+tid);
					if( !isAcceptMID(mid) || !isAcceptTID(tid) ) {
						return util.responseText("invalidID", "text/plain; charset=UTF-8"); 
					}
					String sql = "SELECT count(*) FROM umovie WHERE mylistid=? AND movieid=? AND threadid=?";
					PreparedStatement pstmt = con.prepareStatement(sql);
					pstmt.setString(1,mylist);
					pstmt.setString(2,mid);
					pstmt.setString(3,tid);
					ResultSet rs;
					rs = pstmt.executeQuery();
					rs.next();
					debug(path,"same umovie nums="+rs.getInt(1));
					// 動画がすでに入っている
					if( rs.getInt(1) != 0 ) {
						return util.responseText("overlap", "text/plain; charset=UTF-8"); 
					}
					sql = "SELECT count(*) FROM umylist WHERE id=?";
					pstmt = con.prepareStatement(sql);
					pstmt.setString(1,mylist);
					rs = pstmt.executeQuery();
					rs.next();
					// 存在しないマイリスト
					if( rs.getInt(1) != 1 ) {
						return util.responseText("invalidMylist", "text/plain; charset=UTF-8"); 
					}

					sql = "INSERT INTO umovie (mylistid,movieid,threadid) VALUES(?,?,?)";
					pstmt = con.prepareStatement(sql);
					pstmt.setString(1,mylist);
					pstmt.setString(2,mid);
					pstmt.setString(3,tid);
					pstmt.execute();
					return util.responseText("succeeded", "text/plain; charset=UTF-8"); 
				} else {
					return util.responseText("failed", "text/plain; charset=UTF-8"); 
				}
			} else if( path.equals("/remove") ) {
				if( get.get("mid") != null && get.get("mylist") != null  && get.get("tid") != null ) {
					String mylist = replace((String)get.get("mylist"));
					String mid = replace((String)get.get("mid"));
					String tid = replace((String)get.get("tid"));
					debug(path,"mylist="+mylist+" mid="+mid+" tid"+tid);
					String sql = "DELETE FROM umovie WHERE mylistid=? AND movieid=? AND threadid=?";
					PreparedStatement pstmt = con.prepareStatement(sql);
					pstmt.setString(1,mylist);
					pstmt.setString(2,mid);
					pstmt.setString(3,tid);
					pstmt.execute();
					return util.responseText("succeeded", "text/plain; charset=UTF-8"); 
				} else {
					return util.responseText("failed", "text/plain; charset=UTF-8"); 
				}
			} else if( path.equals("/mremove") ) {
				if( get.get("mylist") != null ) {
					String mylist = replace((String)get.get("mylist"));
					debug(path,"mylist="+mylist);
					String sql = "DELETE FROM umovie WHERE mylistid=?";
					PreparedStatement pstmt = con.prepareStatement(sql);
					pstmt.setString(1,mylist);
					pstmt.execute();
					sql = "DELETE FROM umylist WHERE id=?";
					pstmt = con.prepareStatement(sql);
					pstmt.setString(1,mylist);
					pstmt.execute();
					return util.responseText("succeeded", "text/plain; charset=UTF-8"); 
				} else {
					return util.responseText("failed", "text/plain; charset=UTF-8"); 
				}
			} else if( path.equals("/ajax") ) {
				for(int i = 0; i < 2; i++) {
					String sql = "select * from umylist";
					ResultSet rs = stmt.executeQuery("select * from umylist");
					String s = (i==0?"{":"["),e = (i==0?"}":"]");
					String uMylist = s+"\n";
					while( rs.next() ) {
						if( !uMylist.equals(s+"\n") ) {
							uMylist += ",\n";
						}
						String uMylistId = rs.getString("id");
						String name = rs.getString("name");
						uMylist += (i==0?"\""+uMylistId+"\":{":"{\"id\":"+uMylistId+",")+"\"name\":\""+name+"\",\"movies\":["+getMovies(uMylistId)+"]}";
					}
					uMylist += "\n"+e+";";
					id += "uMylist"+i+" = "+uMylist+"\n";
					rs.close();
				}
				return util.responseText(id,"text/javascript; charset=UTF-8");
			} else if( path.equals("/rename") ) {
				if( get.get("mylist") != null && get.get("name") != null ) {
					String mylist = replace((String)get.get("mylist"));
					String name = (String)replace(URLDecoder.decode((String)get.get("name"),"utf8"));
					debug(path,"mylist="+mylist+" name="+name);
					String sql = "SELECT COUNT(*) FROM umylist where name=?";
					ResultSet rs;
					PreparedStatement pstmt = con.prepareStatement(sql);
					pstmt.setString(1,name);
					rs = pstmt.executeQuery();
					rs.next();
					debug(path,"same name nums="+rs.getInt(1));
					// 設定されていて同じ名前のマイリストがすでに入っている
					if( !System.getProperty("umylistUniqueMyList", "false").equals("false") && rs.getInt(1) != 0 ) {
						debug(path,"overlap");
						return util.responseText("overlap", "text/plain; charset=UTF-8"); 
					}
					rs.close();
					sql = "UPDATE umylist SET name=? WHERE id=?";
					pstmt = con.prepareStatement(sql);
					pstmt.setString(1,name);
					pstmt.setString(2,mylist);
					pstmt.execute();
					return util.responseText("succeeded","text/javascript; charset=UTF-8");
				} else {
					return util.responseText("failed", "text/plain; charset=UTF-8"); 
				}
			} else if( path.equals("/mylist/add") ) {
				if( get.get("mylist") != null ) {
					String sql = "SELECT COUNT(*) FROM mylist where mylistid=?";
					String mylist = (String)replace(URLDecoder.decode((String)get.get("mylist"),"utf8"));
					debug(path,"mylist="+mylist);
					ResultSet rs;
					PreparedStatement pstmt = con.prepareStatement(sql);
					pstmt.setString(1,mylist);
					rs = pstmt.executeQuery();
					rs.next();
					debug(path,"same name nums="+rs.getInt(1));
					// 設定されていて同じ名前のマイリストがすでに入っている
					if( rs.getInt(1) != 0 ) {
						debug(path,"overlap");
						return util.responseText("overlap", "text/plain; charset=UTF-8");
					}
					rs.close();
					sql = "INSERT INTO mylist (mylistid) VALUES(?)";
					pstmt = con.prepareStatement(sql);
					pstmt.setString(1,mylist);
					pstmt.execute();
					return util.responseText("succeeded", "text/plain; charset=UTF-8"); 
				} else {
					return util.responseText("failed", "text/plain; charset=UTF-8"); 
				}
			}  else if( path.equals("/mylist/remove") ) {
				if( get.get("id") != null ) {
					String mylist = replace((String)get.get("id"));
					debug(path,"mylist="+mylist);
					String sql = "DELETE FROM mylist WHERE id=?";
					PreparedStatement pstmt = con.prepareStatement(sql);
					pstmt.setString(1,mylist);
					pstmt.execute();
					return util.responseText("succeeded", "text/plain; charset=UTF-8"); 
				} else {
					return util.responseText("failed", "text/plain; charset=UTF-8"); 
				}
			} else if( path.equals("/mylist/list") ) {
				id += "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
				id += "<mylist>\n";
				ResultSet rs = stmt.executeQuery("select * from mylist");
				while( rs.next() ) {
					id += "\t<list>\n";
					id += "\t\t<id>"+rs.getString("id")+"</id>\n";
					id += "\t\t<mylistid>"+rs.getString("mylistid")+"</mylistid>\n";
					id += "\t</list>\n";
				}
				rs.close();
				id += "</mylist>";
				return new StringResource(id);
			}
		} catch(Exception e) {
			return util.responseText(e+"", "text/plain; charset=UTF-8"); 
		}
		return util.responseText("", "text/plain; charset=UTF-8"); 
	}
}